/************************************************************************
 *									*
 *		r^f@botvO				*
 *									*
 *				: qr|QRQbf[^M		*
 *		t@C	: intrs2.c				*
 *									*
 ************************************************************************/

#pragma	SECTION	PROG=intrs2

#include "sg_cpu.h"

/*	֐	*/
static	void	mode_check(void);
static	void	set_PAbit(void);

/*=======================================================================
 |
 |		qr|QRQb荞ݏ
 |
 |	void	intrs2()
 |
 =======================================================================*/
#pragma	INTERRUPT
void	intrs2()
{
	byte	ch, isr, srb;

	/* 荞݃Xe[^XWX^ǂݍ */
	isr = *REG_DUART_ISR;

	if (isr & BIT1) {	/* bg|`荞݁H */
		/* bg|`荞݋֎~ */
		*REG_DUART_IMR = 0x20;
	}

	if (isr & BIT5) {	/* bg|a荞݁H */
		while ((srb = *REG_DUART_SRB) & BIT0) {
			if (srb & (BIT4 | BIT5 | BIT6)) {/* MG[LH */
				/* obt@f[^ǂݎ̂ */
				ch = *REG_DUART_RHRB;

				/* MJE^NA */
				rs_counter = 0;
			} else {
				/* Mf[^ǂݍ */
				ch = *REG_DUART_RHRB;

				switch (rs_counter) {
				case 0:
					if (ch == '#') {
						/* ubNԃ^C}[Zbg */
						tmc_rsblock = 0;
						tmf_rsblock = TIMER_START;
						tmo_rsblock = 0;

						/* ԃ^C}[Zbg */
						tmc_rschar = 0;
						tmf_rschar = TIMER_START;

						/* MJE^Zbg */
						rs_counter = 1;
					}
					break;
				case 1:
					if (ch == 'S') {
						/* MJE^Zbg */
						rs_counter = 2;
					} else {
						/* ԃ^C}[~ */
						tmf_rschar = TIMER_STOP;

						/* MJE^NA */
						rs_counter = 0;
					}
					break;
				case 2:
					/* Mf[^Z[u */
					rs_receive_data = ch;

					/* MJE^Zbg */
					rs_counter = 3;
					break;
				}
			}
		}

		if (rs_counter == 3) {
			/* ԃ^C}[~ */
			tmf_rschar = TIMER_STOP;

			if (gsc_start_flag == 0) {	/* PځH */
				/* frb{[hN */
				*REG_GSC_OUTPUT = 0x0000;
				gsc_start_flag = 1;
			}

			/* [hύX`FbN */
			mode_check();

			/* o^`rbgZbg */
			set_PAbit();

			/* MJE^NA */
			rs_counter = 0;
		}
	}
}
#pragma	INTERRUPT-

/*=======================================================================
 |
 |		\[hύX`FbN
 |
 |	void	mode_check()
 |
 =======================================================================*/
static	void	mode_check()
{
	if (rs_receive_data & BIT7) {
		/* ʏ탂[h */
		if (rs_receive_data & BIT2)	/* OtBbN\H */
			sg_mode = MODE_AI;
		else {
			if (rs_receive_data & BIT3)
				sg_mode = MODE_HUD;
			else
				sg_mode = MODE_HDD;
		}
	} else {
		/* eiX[h */
		switch (rs_receive_data) {
		case 0x80:	/* ʏ탂[h|Oƃ[hj[\ */
			if (sg_mode == MODE_AI || sg_mode == MODE_HUD
						|| sg_mode == MODE_HDD)
				sg_mode = MODE_MENU;
			break;
		case 0x82:	/* Oƃf[^\|Oƃ[hj[\ */
			if (sg_mode == MODE_DATA)
				sg_mode = MODE_MENU;
			break;
		case 0x84:	/* Oƃf[^j[\|Oƃf[^\ */
			if (sg_mode == MODE_MENU)
				sg_mode = MODE_DATA;
			break;
		case 0xa0:	/* Oƃf[^L^I */
			if (sg_mode == MODE_MENU)
				memorizing_flag = 0;
			break;
		case 0xa1:	/* Oƃf[^L^Jn */
			if (sg_mode == MODE_MENU)
				memorizing_flag = 1;
			break;
		}
	}
}

/*=======================================================================
 |
 |		o^`rbgݒ菈
 |
 |	void	set_PAbit()
 |
 =======================================================================*/
static	void	set_PAbit()
{
	/* So^`rbgNA */
	pa_bit.PA00001 = 0x0000;
	pa_bit.PA00002 = 0x0000;
	pa_bit.PA00003 = 0x0000;
	pa_bit.PA00004 = 0x0000;
	pa_bit.PA00005 = 0x0000;
	pa_bit.PA00006 = 0x0000;

	/* [hʂɂo^`rbgZbg */
	switch (sg_mode) {
	case MODE_AI:		/* `h\[h */
		pa_bit.PA00001 |=
			PA1_F103  | PA1_F104A | PA1_F104B | PA1_F104C |
			PA1_F104D | PA1_F104E | PA1_F104F | PA1_F105A |
			PA1_F105B | PA1_F105C | PA1_F106  | PA1_F107  |
			PA1_F108  | PA1_F109A;

		/* pCbgRg */
		if (rs_receive_data & BIT5)	/* GOOD ? */
			pa_bit.PA00001 |= PA1_F112A;
		if (rs_receive_data & BIT6)	/* NO GOOD ? */
			pa_bit.PA00001 |= PA1_F112B;

		/* s`rُ펞V{ */
		if (orgdata.IASPDT & BIT0)
			pa_bit.PA00002 |= PA2_F113C;

		/* `ksُ펞V{ */
		if (orgdata.IHBALT == 0x8000)
			pa_bit.PA00002 |= PA2_F113D;

		/* PTTRa`G[ */
		if (tmo_1553B)
			pa_bit.PA00002 |= PA2_F113A | PA2_F113B | PA2_F113C |
					  PA2_F113D;
		break;
	case MODE_HUD:		/* gtc\[h */
		pa_bit.PA00003 |=
			PA3_F202 | PA3_F203 | PA3_F204 | PA3_F205 |
			PA3_F207 | PA3_F208 | PA3_F209 | PA3_F210;

		/* xVeB[xN^ */
		if (tmo_1553B == 0)
			pa_bit.PA00003 |= PA3_F206;

		/* pCbgRg */
		if (rs_receive_data & BIT5)	/* GOOD ? */
			pa_bit.PA00003 |= PA3_F112A;
		if (rs_receive_data & BIT6)	/* NO GOOD ? */
			pa_bit.PA00003 |= PA3_F112B;

		/* h`rُ펞V{ */
		if (orgdata.IASPDI & BIT0)
			pa_bit.PA00003 |= PA3_F211B;

		/* `ksُ펞V{ */
		if (orgdata.IHBALT == 0x8000)
			pa_bit.PA00003 |= PA3_F211D;

		/* PTTRa`G[ */
		if (tmo_1553B)
			pa_bit.PA00003 |= PA3_F211A | PA3_F211B | PA3_F211C |
					  PA3_F211D;
		break;
	case MODE_HDD:		/* gcc\[h */
		pa_bit.PA00004 |= PA4_F301 | PA4_F302 | PA4_F303;

		/* pCbgRg */
		if (rs_receive_data & BIT5)	/* GOOD ? */
			pa_bit.PA00004 |= PA4_F112A;
		if (rs_receive_data & BIT6)	/* NO GOOD ? */
			pa_bit.PA00004 |= PA4_F112B;

		/* s`rُ펞V{ */
		if (orgdata.IASPDT & BIT0)
			pa_bit.PA00004 |= PA4_F304A;

		/* `ksُ펞V{ */
		if (orgdata.IHBALT == 0x8000)
			pa_bit.PA00004 |= PA4_F304B;

		/* PTTRa`G[ */
		if (tmo_1553B)
			pa_bit.PA00004 |= PA4_F304A | PA4_F304B;
		break;
	case MODE_MENU:		/* j[\[h */
		/* Œp^[ */
		pa_bit.PA00005 |= PA5_F401;

		/* L^^L^IbZ[W */
		if (memorizing_flag == 0)
			pa_bit.PA00005 |= PA5_F403;	/* L^I */
		else
			pa_bit.PA00005 |= PA5_F402;	/* L^ */
		break;
	case MODE_DATA:		/* OƓxf[^\[h */
		pa_bit.PA00006 |=
			PA6_F501 | PA6_F502 | PA6_F503 | PA6_F504 |
			PA6_F505 | PA6_F506 | PA6_F507 | PA6_F508 |
			PA6_F509;
		break;
	}

	/* rfI\Rg[WX^ݒ */
	if (rs_receive_data & BIT0)
		video_control = 0x900;	/* rfI\[h */
	else if (rs_receive_data & BIT1)
		video_control = 0x500;	/* rfI{OtBbN\[h */
	else if (rs_receive_data & BIT2)
		video_control = 0x100;	/* OtBbN\[h */

	if (rs_receive_data & BIT4)
		video_control |= 0x20;	/* ΁^ */
	else
		video_control |= 0x10;	/* ^ */
}
